#pragma once

#include "stdafx.h"

typedef struct
{
	string name;
	void *func;
} SNamedFunction;

void *__zcoreFindNamedFunction(const vector<SNamedFunction> &funcs, const string &name);

bool __zcoreGamemodeChanged(void);
bool __zcoreLoadGamemode(void);
void __zcoreUnloadGamemode(void);

void __zcoreShutdown(void);

void __zcoreException(void);

cell AMX_NATIVE_CALL zcoreTimer100(AMX* amx, cell* params);

//OnFilterScriptExit();
//-cell AMX_NATIVE_CALL zcoreOnFilterScriptExit(AMX *amx, cell *params);
//OnFilterScriptInit();
//-cell AMX_NATIVE_CALL zcoreOnFilterScriptInit(AMX *amx, cell *params);

//OnGameModeExit();
//-cell AMX_NATIVE_CALL zcoreOnGameModeExit(AMX *amx, cell *params);
//OnGameModeInit();
//-cell AMX_NATIVE_CALL zcoreOnGameModeInit(AMX *amx, cell *params);

//OnObjectMoved(objectid);
cell AMX_NATIVE_CALL zcoreOnObjectMoved(AMX *amx, cell *params);
//OnPlayerCommandText(playerid, cmdtext[]);
cell AMX_NATIVE_CALL zcoreOnPlayerCommandText(AMX *amx, cell *params);
//OnPlayerConnect(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerConnect(AMX *amx, cell *params);
//OnPlayerDeath(playerid, killerid, reason);
cell AMX_NATIVE_CALL zcoreOnPlayerDeath(AMX *amx, cell *params);
//OnPlayerDisconnect(playerid, reason);
cell AMX_NATIVE_CALL zcoreOnPlayerDisconnect(AMX *amx, cell *params);
//OnPlayerEnterCheckpoint(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerEnterCheckpoint(AMX *amx, cell *params);
//OnPlayerEnterRaceCheckpoint(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerEnterRaceCheckpoint(AMX *amx, cell *params);
//OnPlayerEnterVehicle(playerid, vehicleid, ispassenger);
cell AMX_NATIVE_CALL zcoreOnPlayerEnterVehicle(AMX *amx, cell *params);
//OnPlayerExitedMenu(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerExitedMenu(AMX *amx, cell *params);
//OnPlayerExitVehicle(playerid, vehicleid);
cell AMX_NATIVE_CALL zcoreOnPlayerExitVehicle(AMX *amx, cell *params);
//OnPlayerInfoChange(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerInfoChange(AMX *amx, cell *params);
//OnPlayerInteriorChange(playerid, newinteriorid, oldinteriorid);
cell AMX_NATIVE_CALL zcoreOnPlayerInteriorChange(AMX *amx, cell *params);
//OnPlayerKeyStateChange(playerid, newkeys, oldkeys);
cell AMX_NATIVE_CALL zcoreOnPlayerKeyStateChange(AMX *amx, cell *params);
//OnPlayerLeaveCheckpoint(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerLeaveCheckpoint(AMX *amx, cell *params);
//OnPlayerLeaveRaceCheckpoint(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerLeaveRaceCheckpoint(AMX *amx, cell *params);
//OnPlayerObjectMoved(playerid, objectid);
cell AMX_NATIVE_CALL zcoreOnPlayerObjectMoved(AMX *amx, cell *params);
//OnPlayerPickUpPickup(playerid, pickupid);
cell AMX_NATIVE_CALL zcoreOnPlayerPickUpPickup(AMX *amx, cell *params);
//OnPlayerPrivmsg(playerid, recieverid, text[]);
cell AMX_NATIVE_CALL zcoreOnPlayerPrivmsg(AMX *amx, cell *params);
//OnPlayerRequestClass(playerid, classid);
cell AMX_NATIVE_CALL zcoreOnPlayerRequestClass(AMX *amx, cell *params);
//OnPlayerRequestSpawn(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerRequestSpawn(AMX *amx, cell *params);
//OnPlayerSelectedMenuRow(playerid, row);
cell AMX_NATIVE_CALL zcoreOnPlayerSelectedMenuRow(AMX *amx, cell *params);
//OnPlayerSpawn(playerid);
cell AMX_NATIVE_CALL zcoreOnPlayerSpawn(AMX *amx, cell *params);
//OnPlayerStateChange(playerid, newstate, oldstate);
cell AMX_NATIVE_CALL zcoreOnPlayerStateChange(AMX *amx, cell *params);
//OnPlayerText(playerid, text[]);
cell AMX_NATIVE_CALL zcoreOnPlayerText(AMX *amx, cell *params);
//OnRconCommand(cmd[]);
cell AMX_NATIVE_CALL zcoreOnRconCommand(AMX *amx, cell *params);
//OnVehicleDeath(vehicleid, killerid);
cell AMX_NATIVE_CALL zcoreOnVehicleDeath(AMX *amx, cell *params);
//OnVehicleMod(vehicleid, componentid);
cell AMX_NATIVE_CALL zcoreOnVehicleMod(AMX *amx, cell *params);
//OnVehiclePaintjob(vehicleid, paintjobid);
cell AMX_NATIVE_CALL zcoreOnVehiclePaintjob(AMX *amx, cell *params);
//OnVehicleRespray(vehicleid, color1, color2);
cell AMX_NATIVE_CALL zcoreOnVehicleRespray(AMX *amx, cell *params);
//OnVehicleSpawn(vehicleid);
cell AMX_NATIVE_CALL zcoreOnVehicleSpawn(AMX *amx, cell *params);
